* PACKAGE DINTG  !" ϳ ʬ
*
*"   [HIS] 92/11/26(takepiro)
*"         99/11/10(takepiro) BNDRY interface ѹȼ
*
***********************************************************************
      SUBROUTINE TINTGR         !" ʬ ( ڥȥ )
     M         ( WDTOR , WDPOR , WDDPOR, WDT   , 
     I           WTTOR , WTPOR , WTT   , 
     I           DELT  , ITRUNG, 
     C           FLAPLA, NMO, 
     C           ARAD  , DRAD             )
*
*"                   4-th order Runge-Kutta scheme
*
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
#else
#include        "zcdim.F"                    !" ʻȿ
#endif
*
*   [MODIFY] 
      REAL       WDTOR ( NMDIM , 0:KMAX     )  !" ȥ 
      REAL       WDPOR ( NMDIM , 0:KMAX     )  !" ݥ 
      REAL       WDDPOR( NMDIM , 0:KMAX     )  !" ݥ D_l 
      REAL       WDT   ( NMDIM , 0:KMAX     )  !"   
*
*   [INPUT] 
      REAL       WTTOR ( NMDIM, 0:KMAX      )  !" ȥ 
      REAL       WTPOR ( NMDIM, 0:KMAX      )  !" ݥ 
      REAL       WTT   ( NMDIM, 0:KMAX      )  !"   
*
      INTEGER    ITRUNG                        !" Runge-Kutta ѿ
      REAL       DELT                          !" ֹߦt
*
      REAL       FLAPLA( NMDIM  )              !" ץ饷η
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX )   !" ڥȥź
*
      REAL       ARAD  ( 0:KMAX )              !" ٥()
      REAL       DRAD  ( 0:KMAX )              !" ()
*
*   [INTERNAL WORK] 
      REAL       WDTOR0( NMDIM , 0:KMAX     )  !" ȥ 
      REAL       WDDPO0( NMDIM , 0:KMAX     )  !" ݥ D_l 
      REAL       WDT0  ( NMDIM , 0:KMAX     )  !"   
*"       : Τͤ򥻡 
*
      REAL       WDTOR1( NMDIM , 0:KMAX     )  !" ȥ 
      REAL       WDDPO1( NMDIM , 0:KMAX     )  !" ݥ D_l 
      REAL       WDT1  ( NMDIM , 0:KMAX     )  !"   
*"       : ͤĤ߽Ťͤ
*
      REAL       DELTA1, DELTA2, DELTA3
      REAL       WEIGH1, WEIGH2, WEIGH3, WEIGH4
      INTEGER    NM, K
*
*"         < 0.  >
*
      IF ( ITRUNG . EQ. 1 ) THEN
         DELTA1  =  DELT * 0.5
         DELTA2  =  DELT * 0.5
         DELTA3  =  DELT
*
         WEIGH1  =       DELT / 6.
         WEIGH2  =  2. * DELT / 6. 
         WEIGH3  =  2. * DELT / 6. 
         WEIGH4  =       DELT / 6. 
*
         CALL COPY ( WDTOR0, WDTOR , NMDIM*KDIM )
         CALL COPY ( WDDPO0, WDDPOR, NMDIM*KDIM )
         CALL COPY ( WDT0,   WDT   , NMDIM*KDIM )
         CALL COPY ( WDTOR1, WDTOR , NMDIM*KDIM )
         CALL COPY ( WDDPO1, WDDPOR, NMDIM*KDIM )
         CALL COPY ( WDT1,   WDT   , NMDIM*KDIM )
      ENDIF
*
*"         < 1. ʬ >
*
*
      IF ( ITRUNG . EQ. 1 )THEN
         DO 1100 K = 0 , KMAX
            DO 1100 NM = 1 , NMDIM
*"    < ȥ > 
               WDTOR ( NM,K ) = WDTOR0( NM,K )
     &                     + WTTOR ( NM,K )* DELTA1
               WDTOR1( NM,K ) = WDTOR1( NM,K )
     &                     + WTTOR ( NM,K )* WEIGH1
*"    <  >
               WDT ( NM,K ) = WDT0 ( NM,K )
     &                     + WTT ( NM,K )* DELTA1
               WDT1( NM,K ) = WDT1 ( NM,K )
     &                     + WTT ( NM,K )* WEIGH1
 1100    CONTINUE
         DO 1150 K = 0 , KMAX
            DO 1150 NM = 1 , NMDIM
*"    < ݥ >
               WDDPOR ( NM,K ) = WDDPO0 ( NM,K )
     &                     + WTPOR ( NM,K )* DELTA1
               WDDPO1 ( NM,K ) = WDDPO1 ( NM,K )
     &                     + WTPOR ( NM,K )* WEIGH1
 1150    CONTINUE 
*
      ELSE IF ( ITRUNG . EQ. 2 )THEN
         DO 1200 K = 0 , KMAX
            DO 1200 NM = 1 , NMDIM
*"    < ȥ > 
               WDTOR ( NM,K ) = WDTOR0( NM,K )
     &                     + WTTOR ( NM,K )* DELTA2
               WDTOR1( NM,K ) = WDTOR1( NM,K )
     &                     + WTTOR ( NM,K )* WEIGH2
*"    <  >
               WDT ( NM,K ) = WDT0 ( NM,K )
     &                     + WTT ( NM,K )* DELTA2
               WDT1( NM,K ) = WDT1 ( NM,K )
     &                     + WTT ( NM,K )* WEIGH2
 1200    CONTINUE
         DO 1250 K = 0 , KMAX
            DO 1250 NM = 1 , NMDIM
*"    < ݥ >
               WDDPOR ( NM,K ) = WDDPO0 ( NM,K )
     &                     + WTPOR ( NM,K )* DELTA2
               WDDPO1 ( NM,K ) = WDDPO1 ( NM,K )
     &                     + WTPOR ( NM,K )* WEIGH2
 1250    CONTINUE 
*
      ELSE IF ( ITRUNG . EQ. 3 )THEN
         DO 1300 K = 0 , KMAX
            DO 1300 NM = 1 , NMDIM
*"    < ȥ > 
               WDTOR ( NM,K ) = WDTOR0( NM,K )
     &                     + WTTOR ( NM,K )* DELTA3
               WDTOR1( NM,K ) = WDTOR1( NM,K )
     &                     + WTTOR ( NM,K )* WEIGH3
*"    <  >
               WDT ( NM,K ) = WDT0 ( NM,K )
     &                     + WTT ( NM,K )* DELTA3
               WDT1( NM,K ) = WDT1 ( NM,K )
     &                     + WTT ( NM,K )* WEIGH3
 1300    CONTINUE
         DO 1350 K = 0, KMAX
            DO 1350 NM = 1 , NMDIM
*"    < ݥ >
               WDDPOR ( NM,K ) = WDDPO0 ( NM,K )
     &                     + WTPOR ( NM,K )* DELTA3
               WDDPO1 ( NM,K ) = WDDPO1 ( NM,K )
     &                     + WTPOR ( NM,K )* WEIGH3
 1350    CONTINUE 
*
      ELSE IF ( ITRUNG . EQ. 4 ) THEN
         DO 1400 K = 0, KMAX
            DO 1400 NM = 1, NMDIM
*"    < ȥ >
               WDTOR( NM,K ) = WDTOR1( NM,K )
     &                     + WTTOR ( NM,K )* WEIGH4
*"    <  >
               WDT ( NM,K ) = WDT1 ( NM,K )
     &                     + WTT ( NM,K )* WEIGH4
 1400    CONTINUE
         DO 1450 K = 0 , KMAX
            DO 1450 NM = 1 , NMDIM
*"    < ݥ > 
               WDDPOR ( NM,K ) = WDDPO1 ( NM,K )
     &                     + WTPOR ( NM,K )* WEIGH4
 1450    CONTINUE 
      ELSE
         CALL MSGDMP ( 'E', 'TINTGR', 
     &                 'THE ORDER OF RUNGE-KUTTA SCHEME INVALID' )
      ENDIF
*
*"         < 2.  >
*
      CALL BNDRY
     M       ( WDTOR , WDPOR , WDT  , WDDPOR, 
     C         NMO,
     C         ARAD  , DRAD                   )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE MOVGD        !"  ʻͤΰư
     O         ( GBU   , GBV   , GBW   , GBT   , 
     O           GBTOR , GBPOR ,
     I           GAU   , GAV   , GAW   , GAT   , 
     I           GATOR , GAPOR                          )
*
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
#else
#include        "zcdim.F"                    !" ʻȿ
#endif
*
*   [OUTPUT] 
      REAL       GBU   ( IDIM, JDIM, KDIM )  !"   
      REAL       GBV   ( IDIM, JDIM, KDIM )  !"   
      REAL       GBW   ( IDIM, JDIM, KDIM )  !" ľ 
      REAL       GBT   ( IDIM, JDIM, KDIM )  !"   
      REAL       GBTOR ( IDIM, JDIM, KDIM )  !" ȥ 
      REAL       GBPOR ( IDIM, JDIM, KDIM )  !"ݥ 
*"       : ʻǡ(t-t) ->  ʻǡ(t)
*
*   [INPUT] 
      REAL       GAU   ( IDIM, JDIM, KDIM )  !"   
      REAL       GAV   ( IDIM, JDIM, KDIM )  !"   
      REAL       GAW   ( IDIM, JDIM, KDIM )  !" ľ 
      REAL       GAT   ( IDIM, JDIM, KDIM )  !"   
      REAL       GATOR ( IDIM, JDIM, KDIM )  !" ȥ 
      REAL       GAPOR ( IDIM, JDIM, KDIM )  !" ݥ 
*"       : ʻǡ(t)
*
      CALL COPY ( GBU   , GAU   , IDIM*JDIM*KDIM )
      CALL COPY ( GBV   , GAV   , IDIM*JDIM*KDIM )
      CALL COPY ( GBW   , GAW   , IDIM*JDIM*KDIM )
      CALL COPY ( GBT   , GAT   , IDIM*JDIM*KDIM )
      CALL COPY ( GBTOR , GATOR , IDIM*JDIM*KDIM )
      CALL COPY ( GBPOR , GAPOR , IDIM*JDIM*KDIM )
*
      RETURN
      END
