* PACKAGE DGDYN  !" ϳ  
*
*"  [HIS]  93/02/01(takepiro)
*"         93/02/16(takepiro)
*"         93/09/07(takepiro) ư̤γѱư̥եåǤθ
*
*********************************************************************
      SUBROUTINE GRDDYN      !"  ʻǤϳع 
     O         ( GTUA  , GTVA  , GTWA  , 
     O           GTUT  , GTVT  , GTWT  , GTH   ,
     I           GAU   , GAV   , GAW   , GAT   ,
     C           UVFACT, FLAPLA, 
     C           ALAT  , DLAT  , ARAD  , DRAD    )
*
*
*   [PARAMETER]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
#else
#include        "zcdim.F"                    !" ʻȿ
#endif
*
*   [OUTPUT]
      REAL       GTUA  ( IDIM*JDIM, 0:KDIM ) !" ư̰ήգ
      REAL       GTVA  ( IDIM*JDIM, 0:KDIM ) !" ̱ư̰ή֣
      REAL       GTWA  ( IDIM*JDIM, 0:KDIM ) !" ľưѲ
      REAL       GTH   ( IDIM*JDIM, 0:KDIM ) !" ٻѲ  
*
      REAL       GTUT  ( IDIM*JDIM, 0:KDIM ) !" ή  գ
      REAL       GTVT  ( IDIM*JDIM, 0:KDIM ) !" ̰ή  ֣
      REAL       GTWT  ( IDIM*JDIM, 0:KDIM ) !" ٱľή  
*
*   [INPUT]
      REAL       GAU   ( IDIM*JDIM, 0:KDIM ) !"   u(t)
      REAL       GAV   ( IDIM*JDIM, 0:KDIM ) !"   v(t)
      REAL       GAW   ( IDIM*JDIM, 0:KDIM ) !" ľ w(t)
      REAL       GAT   ( IDIM*JDIM, 0:KDIM ) !"   (t)
*
      REAL       UVFACT( IDIM*JDIM )         !" uU Υե
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
*
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
      REAL       ARAD  ( 0:KDIM )            !" ٥()
      REAL       DRAD  ( 0:KDIM )            !" ()
*
*   [INTERNAL WORK]
      COMMON    /COMWRK/ FLU, FLV, FLW
      REAL       FLU( IDIM*JDIM, 0:KDIM )    !" ư̥եå u
      REAL       FLV( IDIM*JDIM, 0:KDIM )    !" ư̥եå v
      REAL       FLW( IDIM*JDIM, 0:KDIM )    !" ư̥եå w
*
      REAL       SINE ( IDIM*JDIM )          !" tan()
*
      INTEGER    IJ, I, J, K
      SAVE       SINE
*
*   [INTERNAL ONCE]
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       OFIRST
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' NONLINEAR DYNAMICS:  DATE=93/09/07'
         OFIRST = .FALSE.
         IJ = 0
         DO 100 J = 1, JDIM
            DO 100 I = 1, IDIM
               IJ = IJ + 1 
               SINE ( IJ ) = SIN ( ALAT(J) )
 100     CONTINUE 
      ENDIF
*
*"         < 1.  գ  > 
*
      DO 1100 K = 0, KDIM
         DO 1100 IJ = 1, IDIM*JDIM
            FLW( IJ,K ) = ARAD( K ) * UVFACT( IJ ) * GAU( IJ,K ) 
     &                     * GAW( IJ,K ) 
            FLV( IJ,K ) = ARAD( K ) * UVFACT( IJ ) * GAU( IJ,K )
     &                     * GAV( IJ,K ) 
            FLU( IJ,K ) = ARAD( K ) * UVFACT( IJ ) * GAU( IJ,K ) 
     &                     * GAU( IJ,K ) 
 1100 CONTINUE
*
      CALL DIVER
     O     (  GTUA  , 
     I        FLU   , FLV  , FLW , 
     C        UVFACT, 
     C        ARAD  , DRAD         )
*
      DO 1200 K = 0, KDIM
         DO 1200 IJ = 1, IDIM*JDIM
            GTUA( IJ,K ) = GTUA( IJ,K )
     &                   / (  ARAD(K) * UVFACT(IJ) )
 1200 CONTINUE
*
      DO 1300 K = 0, KDIM
         DO 1300 IJ = 1, IDIM*JDIM
            GTUA( IJ,K ) = GTUA( IJ,K )
     &                   * UVFACT( IJ ) / ARAD( K )
 1300 CONTINUE
*
*"         < 2.  ֣  > 
*
      DO 2100 K = 0, KDIM
         DO 2100 IJ = 1, IDIM*JDIM
            FLW( IJ,K ) = ARAD( K ) * UVFACT( IJ ) * GAV( IJ,K )
     &                      * GAW( IJ,K ) 
            FLV( IJ,K ) = ARAD( K ) * UVFACT( IJ ) * GAV( IJ,K ) 
     &                      * GAV( IJ,K ) 
            FLU( IJ,K ) = ARAD( K ) * UVFACT( IJ ) * GAV( IJ,K )
     &                      * GAU( IJ,K ) 
 2100 CONTINUE
*
      CALL DIVER
     O     (  GTVA  , 
     I        FLU   , FLV  , FLW , 
     C        UVFACT, 
     C        ARAD  , DRAD         )
*
      DO 2200 K = 0, KDIM
         DO 2200 IJ = 1, IDIM*JDIM
            GTVA( IJ,K ) = GTVA( IJ,K )
     &                   + (   GAU( IJ,K ) * GAU( IJ,K )
     &                       + GAV( IJ,K ) * GAV( IJ,K ) ) * SINE( IJ ) )
 2200 CONTINUE
*
      DO 2300 K = 0, KDIM
         DO 2300 IJ = 1, IDIM*JDIM
            GTVA( IJ,K ) = GTVA( IJ,K )
     &                   / ( ARAD( K ) * ARAD( K ) )
 2300 CONTINUE
*
*"         < 3.    > 
*
      DO 3100 K = 0, KDIM
         DO 3100 IJ = 1, IDIM*JDIM
            FLW( IJ,K ) = GAW( IJ,K ) * GAW( IJ,K ) 
            FLV( IJ,K ) = GAW( IJ,K ) * GAV( IJ,K ) 
            FLU( IJ,K ) = GAW( IJ,K ) * GAU( IJ,K ) 
 3100 CONTINUE
*
      CALL DIVER
     O     (  GTWA  , 
     I        FLU   , FLV  , FLW , 
     C        UVFACT,
     C        ARAD  , DRAD         )
*
      DO 3200 K = 0, KDIM
         DO 3200 IJ = 1, IDIM*JDIM
            GTWA( IJ,K ) = GTWA( IJ,K )
     &                   - (   GAU( IJ,K ) * GAU( IJ,K ) 
     &                       + GAV( IJ,K ) * GAV( IJ,K )   )
     &                    / ARAD( K )
 3200 CONTINUE
*
*"         < 4.  գ ֣ ,   >
*
      DO 4100 K = 0, KDIM
         DO 4100 IJ = 1, IDIM*JDIM
            GTUT( IJ,K ) =  GAU ( IJ,K ) * GAT ( IJ,K )
     &                             * UVFACT ( IJ ) / ARAD( K )
            GTVT( IJ,K ) =  GAV ( IJ,K ) * GAT ( IJ,K )
     &                             * UVFACT ( IJ ) / ARAD( K )
            GTWT( IJ,K ) =  GAW ( IJ,K ) * GAT ( IJ,K )
 4100 CONTINUE
*
*"         < 5.    >
*
      CALL RESET( GTH , IDIM*JDIM*KMAX )
*
      RETURN
      END
*********************************************************************
      SUBROUTINE DIVER    !" ɸϤȯ(ʻҢʻ)
     O     (  GDDIV , 
     I        GDU   , GDV  , GDW , 
     C        UVFACT, 
     C        ARAD  , DRAD         )
*
*   [PARAMETER]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
#else
#include        "zcdim.F"                    !" ʻȿ
#endif
*
*   [OUTPUT]
      REAL       GDDIV( IDIM*JDIM, 0:KDIM )  !" ȯ(ʻ)
*
*   [INPUT]
      REAL       GDU( IDIM*JDIM, 0:KDIM )    !" եå u
      REAL       GDV( IDIM*JDIM, 0:KDIM )    !" եå v
      REAL       GDW( IDIM*JDIM, 0:KDIM )    !" եå w
*
      REAL       UVFACT( IDIM*JDIM )         !" uU Υե
*
      REAL       ARAD  ( 0:KDIM )            !" ٥()
      REAL       DRAD  ( 0:KDIM )            !" ()
*
*   [WORK]
      REAL       GDUU( IDIM*JDIM, 0:KDIM )    !" եå U/r
      REAL       GDVV( IDIM*JDIM, 0:KDIM )    !" եå V/r
      REAL       WDDIV( NMDIM , KMAX )        !" ȯ(ڥȥ)
*
      INTEGER    IJ , K 
*
*"   < 0. ѿѴ >
*
      DO 1000 K = 0, KDIM
         DO 1000 IJ = 1, IDIM*JDIM
            GDUU( IJ, K ) = GDU( IJ, K ) * UVFACT( IJ ) / ARAD( K )
            GDVV( IJ, K ) = GDV( IJ, K ) * UVFACT( IJ ) / ARAD( K )
 1000 CONTINUE 
*
*"   < 1. ڥȥǤȯ >
*
      CALL DIVERW
     O     (  WDDIV , 
     I        GDUU  , GDVV  , GDW  , 
     F       'POS ' ,
     C        ARAD  , DRAD         )
*
*"   < 2. ʻѴ >
*
      CALL W2G
     O     (  GDDIV , 
     I        WDDIV , 
     I        ' '   , 'POS' , KMAX )
*
      RETURN
      END
